// ==========================================================
//
// HC_SR04 Ultrasonic distance measurement (2cm - 4m)
//
// CBP 14-03-15
//
// ==========================================================
  
#define TxPin 10
#define RxPin 11

long travelTime;
float dist;
float normalized;
float mini,maxi;
float lastDist;
float filter[5];
int i = 0;

void setup() {                
  pinMode(TxPin, OUTPUT); 
  pinMode(RxPin, INPUT);   
  Serial.begin(9600);  
  // Chose closest and farthest range you wish to use.
  // The device can do between 2 - 200 cm.
  mini = 10.0;
  maxi = 50.0;
}

void loop() {

  float outputVal;

  // Turn Trigger pin LOW
  digitalWrite(TxPin,LOW);
  delayMicroseconds(5);
  // Now turn it HIGH for 10 microseconds, required by
  // the device
  digitalWrite(TxPin,HIGH);
  delayMicroseconds(10);  
  // And low again
  digitalWrite(TxPin,LOW);  

  // Read the pulse on the Echo pin
  travelTime = pulseIn(RxPin,HIGH);

  Serial.println(travelTime);
  // Convert it into centimetres
  dist = (float)travelTime*330.0/20000.0;
  
  // Now we shall "normalize" the distance which means
  // converting it into the range 0.0 to 1.0
  normalized = (dist - mini)/(maxi-mini);
  // Catch if something has gone wrong
  if(normalized < 0.0)
    normalized = 0.0;
  if(normalized > 1.0)
    normalized = 1.0;

  // Now we are going to digitally "filter" the readings
  // Basically this means storing the last 5 readings and
  // finding the average. Should remove high-frequency noise

  // Store last value in the filter array
  filter[i] = normalized;
  // Ready to store next value
  i++;
  // If array is full, then calculate the average
  if(i == 5) {
    outputVal = filter[0]+filter[1]+filter[2]+filter[3]+filter[4];
   // Serial.println(outputVal/5,3);  
    i = 0;  
  }

 
  delay(10);
}
